# Contributing

**Working on your first Pull Request?** You can learn how from this *free* series
[How to Contribute to an Open Source Project on GitHub](https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github)

## Steps

1. File an issue and discuss your proposed solution first
2. Fork and clone the repo
3. `$ npm install` to install dependencies
4. `$ npm run validate` to validate you've got it working
5. Create a branch for your PR
6. `$ npm run test -- --watch` to watch the file system as you make changes to things
7. Make your changes. Make sure to add yourself to the `.all-contributorsrc`! [More info](https://github.com/kentcdodds/all-contributors)
8. Run `npm run validate` to make sure things look good.
9. Commit your changes following [our standards](https://github.com/stevemao/conventional-changelog-angular/blob/master/convention.md) (optionally use `$ npm run commit` to craft a commit message and commit. If you're having trouble committing, try adding `--no-verify` to your `git commit` command and ask for help in the pull request :-)
10. Push your branch to your fork
11. Make a pull request to `master` on this repository
12. Get merged
13. Celebrate 🎉

## Committing and Pushing changes

As stated earlier, please follow [this convention](https://github.com/stevemao/conventional-changelog-angular/blob/master/convention.md) for your commit messages.

Once you are ready to commit the changes, please use the below commands

1. `git add <files to be comitted>`
2. `$ npm run commit`

... and follow the instruction of the interactive prompt.
